# Download and unpack googletest at configure time
configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
        RESULT_VARIABLE result
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
    message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()
execute_process(COMMAND ${CMAKE_COMMAND} --build .
        RESULT_VARIABLE result
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
    message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

# Prevent overriding the parent project's compiler/linker
# settings on Windows
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

# Add googletest directly to our build. This defines
# the gtest and gtest_main targets.
add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
        ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
        EXCLUDE_FROM_ALL)

# The gtest/gtest_main targets carry header search path
# dependencies automatically when using CMake 2.8.11 or
# later. Otherwise we have to add them here ourselves.
if (CMAKE_VERSION VERSION_LESS 2.8.11)
    include_directories("${gtest_SOURCE_DIR}/include")
endif()

set(TEST_BINARY "Test_EvolutionOfTrust")

include_directories(../src)

# Now simply link against gtest or gtest_main as needed. Eg
add_executable(${TEST_BINARY} Test_PlayRules.cpp Test_CopyCat_Strategy.cpp Test_Grudge_Strategy.cpp Test_Detective_Strategy.cpp Test_Console_Strategy.cpp Test_Game.cpp)
target_link_libraries(${TEST_BINARY} gmock_main EvolutionOfTrustLib)
add_test(NAME Test_PlayRules COMMAND ${TEST_BINARY})
add_test(NAME Test_CopyCat_Strategy COMMAND ${TEST_BINARY})
add_test(NAME Test_Grudge_Strategy COMMAND ${TEST_BINARY})
add_test(NAME Test_Detective_Strategy COMMAND ${TEST_BINARY})
add_test(NAME Test_Console_Strategy COMMAND ${TEST_BINARY})